Linux error messages on one line

Linux error messages on one line

error [- n ] [- q ] [- s ] [- v ] [- t suffixlist ] [- I ignorefile ] [ filename ]

DESCRIPTION

error analyzes error messages produced by a number of compilers and language processors. It replaces the painful, traditional methods of scribbling abbreviations of errors on paper, and permits error messages and source code to be viewed simultaneously.

error looks at error messages, either from the specified file filename or from the standard input, and:

* Determines which language processor produced each error message.

* Determines the file name and line number of the erroneous line.

* Inserts the error message into the source file immediately preceding the erroneous line.

Error messages that can’t be categorized by language processor or content are not inserted into any file, but are sent to the standard output. error touches source files only after all input has been read.

error is intended to be run with its standard input connected with a pipe to the error message source. Some language processors put error messages on their standard error file; others put their messages on the standard output. Hence, both error sources should be piped together into error. For example, when using the csh syntax, the following command analyzes all the error messages produced by whatever programs make (1S) runs when making lint:

example% make -s lint |& error — q — v

error knows about the error messages produced by: as (1), cpp (1), ld (1), cc (1B), make (1S) and other compilers. For all languages except Pascal, error messages are restricted to one line. Some error messages refer to more than one line in more than one file, in which case error duplicates the error message and inserts it in all the appropriate places.

OPTIONS

-n Do not touch any files; all error messages are sent to the standard output.

-q error asks whether the file should be touched. A ` y ‘ or ` n ‘ to the question is necessary to continue. Absence of the — q option implies that all referenced files (except those referring to discarded error messages) are to be touched.

-s Print out statistics regarding the error categorization.

-v After all files have been touched, overlay the visual editor vi with it set up to edit all files touched, and positioned in the first touched file at the first error. If vi (1) can’t be found, try ex (1) or ed (1) from standard places.

-t suffixlist Take the following argument as a suffix list. Files whose suffices do not appear in the suffix list are not touched. The suffix list is dot separated, and ` * ‘ wildcards work. Thus the suffix list:

allows error to touch files ending with ` .c ‘, ` .y’ , ` .f* ‘ and ` .h ‘.

error catches interrupt and terminate signals, and terminates in an orderly fashion.

EXAMPLES

Example 1: Examples of the error command.

In the following C shell (/usr/bin/csh) example, error takes its input from the FORTRAN compiler:

example% f77 -c any.f |& error options 

Here is the same example using the Korn shell (/usr/bin/ksh) :

example% f77 -c any.f 2>&1 | error options 

USAGE

error does one of six things with error messages.

Читайте также:  Linux get active window

synchronize Some language processors produce short errors describing which file they are processing. error uses these to determine the file name for languages that do not include the file name in each error message. These synchronization messages are consumed entirely by error .

discard Error messages from lint that refer to one of the two lint libraries, /usr/lib/lint/llib-lc and /usr/lib/lint/llib-port are discarded, to prevent accidentally touching these libraries. Again, these error messages are consumed entirely by error .

nullify Error messages from lint can be nullified if they refer to a specific function, which is known to generate diagnostics which are not interesting. Nullified error messages are not inserted into the source file, but are written to the standard output. The names of functions to ignore are taken from either the file named .errorrc in the user’s home directory, or from the file named by the — I option. If the file does not exist, no error messages are nullified. If the file does exist, there must be one function name per line.

not file specific Error messages that can’t be intuited are grouped together, and written to the standard output before any files are touched. They are not inserted into any source file.

file specific Error messages that refer to a specific file but to no specific line are written to the standard output when that file is touched.

true errors Error messages that can be intuited are candidates for insertion into the file to which they refer.

Only true error messages are inserted into source files. Other error messages are consumed entirely by error or are written to the standard output. error inserts the error messages into the source file on the line preceding the line number in the error message. Each error message is turned into a one line comment for the language, and is internally flagged with the string ### at the beginning of the error, and %%% at the end of the error. This makes pattern searching for errors easier with an editor, and allows the messages to be easily removed. In addition, each error message contains the source line number for the line the message refers to. A reasonably formatted source program can be recompiled with the error messages still in it, without having the error messages themselves cause future errors. For poorly formatted source programs in free format languages, such as C or Pascal, it is possible to insert a comment into another comment, which can wreak havoc with a future compilation. To avoid this, format the source program so there are no language statements on the same line as the end of a comment.

FILES

~/.errorrc function names to ignore for lint error messages

ATTRIBUTES

See attributes (5) for descriptions of the following attributes:

ATTRIBUTE TYPEATTRIBUTE VALUE
AvailabilitySUNWbtool

SEE ALSO


BUGS

Opens the tty-device directly for user input.

Source files with links make a new copy of the file with only one link to it.

Читайте также:  Red hat enterprise linux rpm

Changing a language processor’s error message format may cause error to not understand the error message.

error , since it is purely mechanical, will not filter out subsequent errors caused by «floodgating» initiated by one syntactically trivial error. Humans are still much better at discarding these related errors.

Pascal error messages belong after the lines affected, error puts them before. The alignment of the `|’ marking the point of error is also disturbed by error.

error was designed for work on CRT ‘s at reasonably high speed. It is less pleasant on slow speed terminals, and was not designed for use on hardcopy terminals.

Источник

How do I write standard error to a file while using «tee» with a pipe?

I know how to use tee to write the output (standard output) of aaa.sh to bbb.out , while still displaying it in the terminal:

I did, I will edit my post to clarify that. I do believe lhunath’s solution will suffice. Thanks for the help all!

12 Answers 12

I’m assuming you want to still see standard error and standard output on the terminal. You could go for Josh Kelley’s answer, but I find keeping a tail around in the background which outputs your log file very hackish and cludgy. Notice how you need to keep an extra file descriptor and do cleanup afterward by killing it and technically should be doing that in a trap ‘. ‘ EXIT .

There is a better way to do this, and you’ve already discovered it: tee .

Only, instead of just using it for your standard output, have a tee for standard output and one for standard error. How will you accomplish this? Process substitution and file redirection:

command > >(tee -a stdout.log) 2> >(tee -a stderr.log >&2) 

Let’s split it up and explain:

>(. ) (process substitution) creates a FIFO and lets tee listen on it. Then, it uses > (file redirection) to redirect the standard output of command to the FIFO that your first tee is listening on.

The same thing for the second:

We use process substitution again to make a tee process that reads from standard input and dumps it into stderr.log . tee outputs its input back on standard output, but since its input is our standard error, we want to redirect tee ‘s standard output to our standard error again. Then we use file redirection to redirect command ‘s standard error to the FIFO’s input ( tee ‘s standard input).

Process substitution is one of those really lovely things you get as a bonus of choosing Bash as your shell as opposed to sh (POSIX or Bourne).

In sh , you’d have to do things manually:

out="$/out.$$" err="$/err.$$" mkfifo "$out" "$err" trap 'rm "$out" "$err"' EXIT tee -a stdout.log < "$out" & tee -a stderr.log < "$err" >&2 & command >"$out" 2>"$err" 

I tried this: $ echo «HANG» > >(tee stdout.log) 2> >(tee stderr.log >&2) which works, but waits for input. Is there a simple reason why this happens?

@SillyFreak I don’t understand what you want to do or what the problem is you’re having. echo test; exit doesn’t produce any output on stdout, so err will remain empty.

thanks for that comment; I figured out what my logical error was afterwards: when invoked as an interactive shell, bash prints a command prompt and echoes exit to stderr. However, if stderr is redirected, bash starts as noninteractive by default; compare /bin/bash 2> err and /bin/bash -i 2> err

Читайте также:  Linux count lines in files

And for those who «seeing is believing», a quick test: (echo «Test Out»;>&2 echo «Test Err») > >(tee stdout.log) 2> >(tee stderr.log >&2)

Can this be used to write both to the same file, but in a synchronized way, so the order of stderr and stdout messages is preserved, while each stream of the supbrocess is still directed to the corresponding stream of the calling process? I don’t know, but I can imagine if tee does some buffering, the subprocess may finish writing something to stdout and write to stderr, but the second tee receiving the stderr message may finish writing it to the file earlier than the first.

This simply redirects standard error to standard output, so tee echoes both to log and to the screen. Maybe I’m missing something, because some of the other solutions seem really complicated.

Note: Since Bash version 4 you may use |& as an abbreviation for 2>&1 | :

That works fine if you want both stdout (channel 1) and stderr (channel 2) logged to the same file (a single file containing the mixture of both stdout and sterr). The other, more complicated solution allows you to separate stdout and stderr into 2 different files (stdout.log and stderr.log, respectively). Sometimes that is important, sometimes it’s not.

The other solutions are far more complicated than necessary in many cases. This one works perfectly for me.

The problem with this method is that you lose the exit/status code from the aaa.sh process, which can be important (e.g. when using in a makefile). You don’t have this problem with the accepted answer.

@Stefaan I believe you can retain exit status if you prepend the command chain with set -o pipefail followed by ; or && if I’m not mistaken.

This may be useful for people finding this via Google. Simply uncomment the example you want to try out. Of course, feel free to rename the output files.

#!/bin/bash STATUSFILE=x.out LOGFILE=x.log ### All output to screen ### Do nothing, this is the default ### All Output to one file, nothing to the screen #exec > $ 2>&1 ### All output to one file and all output to the screen #exec > >(tee $) 2>&1 ### All output to one file, STDOUT to the screen #exec > >(tee -a $) 2> >(tee -a $ >/dev/null) ### All output to one file, STDERR to the screen ### Note you need both of these lines for this to work #exec 3>&1 #exec > >(tee -a $ >/dev/null) 2> >(tee -a $ >&3) ### STDOUT to STATUSFILE, stderr to LOGFILE, nothing to the screen #exec > $ 2>$ ### STDOUT to STATUSFILE, stderr to LOGFILE and all output to the screen #exec > >(tee $) 2> >(tee $ >&2) ### STDOUT to STATUSFILE and screen, STDERR to LOGFILE #exec > >(tee $) 2>$ ### STDOUT to STATUSFILE, STDERR to LOGFILE and screen #exec > $ 2> >(tee $ >&2) echo "This is a test" ls -l sdgshgswogswghthb_this_file_will_not_exist_so_we_get_output_to_stderr_aronkjegralhfaff ls -l $

Источник

Оцените статью
Adblock
detector